#ifndef __PMD1608FS_H__
#define __PMD_1608FS_H__

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>
#include <asm/types.h>

#include "pmd.h"
#include "usb-1608FS.h"

class PMD1608FS
{
public:
  PMD1608FS( bool calibrate=false );
  virtual ~PMD1608FS();

  bool calibrate( float* known_calvolts, int slowly );

  bool set_byte_in();
  bool set_byte_out();
  bool set_bit_in( int bitnum );
  bool set_bit_out( int bitnum );
  bool read_byte( unsigned char& pbyte );
  bool write_byte( unsigned char byte );
  bool read_bit( int bitnum, int& bitval );
  bool write_bit( int bitnum, int bitval );
  bool pulse_bit( int bitnum, int usecs );
  bool read_channel( int channel, int range, float& value );
  bool reset_counter();
  bool read_counter( int& value );

public:
  bool opened;
  int fd;
  char serial[9];
  char calfile[80];
  Calibration_AIN caltab[NGAINS_1608FS][NCHAN_1608FS];
};

#endif // __PMD1608FS_H__
